this.name      = "Tionisla Reporter"; 
this.author    = "eric walch"; 
this.copyright = "© 2011-2012 Creative Commons: attribution, non-commercial, sharealike.";
this.description = "worldScript for the erehwon mission";
this.version   = "1.2.0";


this.startUp = function (){
    this.misjumpInfo = false;
    if (!missionVariables.erehwonReconnaissance) {
        missionVariables.erehwonReconnaissance = "START";
        missionVariables.erehwonFotoShot = "NO";
        missionVariables.erehwonGotStory = "NO";
    } else if (missionVariables.erehwonReconnaissance == "FINISHED") {
        this.cleanUp();
    }
};

this.missionScreenOpportunity = function (){
    if (!player.ship.docked || galaxyNumber != 0) return;
    this.missionOffers();
};

this.missionOffers = function (){
    if (player.ship.dockedStation.isMainStation)
    {
        if (system.ID == 124) {
            if (missionVariables.erehwonReconnaissance == "START") {
                mission.runScreen({
                    title: "Tionisla Chronicle", 
                    messageKey: "erehwonReconnaissance_briefing",
                    choicesKey: "erehwonReconnaissance_choice"
                    }, this.choiceEvaluation
                );
            }
            if (missionVariables.erehwonReconnaissance == "SUCCESS") {
                mission.runScreen({
                    title: "Tionisla Chronicle", 
                    messageKey: "erehwonReconnaissance_debriefing",
                    model: "erehwonStation"
                    }
                );
                mission.displayModel.orientation = [0.75, 0, -0.6, 0];
                delete missionVariables.erehwonGotStory;
                delete missionVariables.erehwonFotoShot;
                delete missionVariables.erehwonPictureCount;
                delete missionVariables.showErehwon;
                delete this.misjumpInfo;
                missionVariables.erehwonReconnaissance = "EPILOGUE";
                missionVariables.erehwonEpilogue = 1;
                missionVariables.erehwonActiontime = clock.days + 30;
                player.ship.removeEquipment("EQ_EREHWON_PHOTOCAMERA");
                mission.setInstructionsKey(null);
                this.$unmarkSystem(124);
                player.credits += 500;
            }
            if (missionVariables.erehwonReconnaissance == "ACCEPTED" && 
                            missionVariables.erehwonPictureCount == 0 &&  missionVariables.erehwonFotoShot == "NO") {
                mission.runScreen({
                    title: "Tionisla Chronicle", 
                    messageKey: "erehwonReconnaissance_failure",
                    choicesKey: "erehwonReconnaissance_choice2"
                    }, this.choiceEvaluation
                );
            }
            if (missionVariables.erehwonReconnaissance == "ACCEPTED" && 
                                player.ship.equipmentStatus("EQ_EREHWON_PHOTOCAMERA") == "EQUIPMENT_DAMAGED") {
                mission.runScreen({
                    title: "Tionisla Chronicle", 
                    messageKey: "erehwonReconnaissance_damaged",
                    choicesKey: "erehwonReconnaissance_choice2"
                    }, this.choiceEvaluation
                );
            }
        }
        if (system.ID == 144 && !this.misjumpInfo) {
            this.misjumpInfo = "BIORLE";
        }
        if (system.ID == 48 && this.misjumpInfo == "BIORLE") {
            this.misjumpInfo = "USLE";
        }
        if (system.ID == 144 && this.misjumpInfo == "USLE") {
            mission.runScreen({
                title: "Tionisla Chronicle", 
                messageKey: "erehwonReconnaissance_biorle"
            });
            this.misjumpInfo = "GIVEN";
        }
        if (missionVariables.erehwonReconnaissance == "DECLINED" && missionVariables.erehwonActiontime > clock.days) {
            mission.runScreen({
                title: "Tionisla Chronicle", 
                messageKey: "erehwonReconnaissance_declined"
            });
            missionVariables.erehwonReconnaissance = "FINISHED";
            missionVariables.erehwonTimerStart = null;
            this.cleanUp();
        }
        if (missionVariables.erehwonReconnaissance == "EPILOGUE" && clock.days > missionVariables.erehwonActiontime) {
            // credits for the idea and next 6 messages go to SandJ
            var erehwonEpilogue = missionVariables.erehwonEpilogue++;
            missionVariables.erehwonActiontime = clock.days + 30; // set new time
            mission.runScreen({
                title: "Tionisla Chronicle", 
                messageKey: "erehwonReconnaissance_epilogue_" + erehwonEpilogue
            });
            switch(erehwonEpilogue) {
                case 1:
                    player.credits += 50;
                    break;
                case 2:
                    player.ship.fuel = 7;
                    break;
                case 3:
                    var narcotics = player.ship.cargoSpaceAvailable;
                    if (narcotics > 35) narcotics = 35; // add a limit
                    manifest.narcotics += narcotics;
                    break;
                case 4:
                    player.credits += 75;
                    break;
                case 5:
                    player.credits += 50;
                    missionVariables.erehwonActiontime += 100; // wait a bit longer for the last one
                    break;
                case 6:
                    manifest.gemStones += 100;
                default:
                    // we ran out of messages. Clean up now.
                    missionVariables.erehwonActiontime = null;
                    missionVariables.erehwonEpilogue = null;
                    missionVariables.erehwonReconnaissance = "FINISHED";
                    this.cleanUp();
                    break;
            }
        }
    } else if (player.ship.dockedStation.displayName == "Erehwon Station"){
        if (missionVariables.erehwonGotStory == "NO") {
            missionVariables.erehwonGotStory = "YES";
            mission.runScreen({
                title: "Tionisla Chronicle", 
                messageKey: "erehwonReconnaissance_story"
            });
        }
        if (missionVariables.erehwonFotoShot == "YES") {
            if (missionVariables.erehwonReconnaissance != "SUCCESS")
            {
                this.$unmarkSystem(144);
                this.$markSystem(124);
            }
            missionVariables.erehwonReconnaissance = "SUCCESS";
            mission.setInstructionsKey("erehwonReconnaissance_missioninfo2");
        }
    }
};


this.choiceEvaluation = function (choice) {
    switch (choice) {

        case "OFFER_ACCEPTED":
            missionVariables.erehwonReconnaissance = "ACCEPTED";
            player.ship.awardEquipment("EQ_EREHWON_PHOTOCAMERA");
            missionVariables.erehwonPictureCount = 10;
            mission.setInstructionsKey("erehwonReconnaissance_missioninfo1");
            this.$markSystem(144);
            mission.runScreen({
                title: "Tionisla Chronicle", 
                messageKey: "erehwonReconnaissance_accepted"
                }
            );
            break;

        case "OFFER_DECLINED":
            missionVariables.erehwonReconnaissance = "DECLINED";
            missionVariables.erehwonActiontime = clock.days + 30;
            break;
    }
};

this.shipWillEnterWitchspace = function (cause) {
    if (!system.isInterstellarSpace) {
        missionVariables.showErehwon = "YES";
        if (this.misjumpInfo == "GIVEN" && (system.ID == 48 || system.ID == 144) && cause === "standard jump") {
            if ((player.ship.targetSystem == 48 || player.ship.targetSystem == 144) && Math.random()< 0.2) {
                player.ship.scriptedMisjump = true;
            }
        }
    } else {
        missionVariables.showErehwon = "NO"; // avoid adding planet on multiple misjumps.
    }

};

this.$markSystem = function (ID) {
    if (0 < oolite.compareVersion("1.77")) {
        mission.markSystem(ID);
    } else {
        mission.markSystem({
                   system: ID,
                   name: "Tionisla Reporter",
                   markerColor: "magentaColor",
                   markerShape: "MARKER_DIAMOND"
        });
    }
}

this.$unmarkSystem = function (ID) {
    if (0 < oolite.compareVersion("1.77")) {
        mission.unmarkSystem(ID);
    } else {
        var ok = mission.unmarkSystem({system: ID, name: "Tionisla Reporter"});
        if (!ok) mission.unmarkSystem(ID); // must have had a legacy marker. Clear that also.
    }
}


this.cleanUp = function () {
    delete this.missionScreenOpportunity;
    delete this.shipWillEnterWitchspace;
};